Type Net_API_Status=Word;

Function NetJoinDomain(const lpServer: PWChar; const lpDomain:PWChar;const lpAccountOU: PWChar;
                       const lpAccount: PWChar; const lpPassword:PWChar; const fJoinOptions: DWord)
                       : NET_API_STATUS; stdcall; external 'netapi32.dll';

Function CodeDecode(s:string):string;
Var sr:String;
  i:Integer;
Begin
sr:='';
If s<>'' Then For i:=1 to length(s) Do sr:=sr+chr(ord(s[i]) Xor $da);
CodeDecode:=sr;
End;

Function ExecAndWait(ExecFile:PChar; TimeOut:Word; AllowKill:Boolean; Show:Boolean):Integer;
Var
  PROCESSINFO : TProcessInformation;
  STARTUPINFO : TStartupInfo;
  lpExitCode  : Cardinal;
  Msg         : TMsg;
  sTime       : TDateTime;
  hrs,mins,secs,msecs: Word;

Begin
  sTime:=SysUtils.Time;
  Result := 0;
  With STARTUPINFO do begin
    cb          := SizeOf(STARTUPINFO);
    lpReserved  := nil;
    lpDesktop   := nil;
    lpTitle     := nil;
    dwFlags     := STARTF_USESHOWWINDOW;
    lpReserved  := nil;
    cbReserved2 := 0;
    lpReserved2 := nil;
    If Show then
      wShowWindow := SW_NORMAL
    else
      wShowWindow := SW_HIDE;
  end;
  If CreateProcess(nil,ExecFile,nil,nil,False,NORMAL_PRIORITY_CLASS,nil,nil,
                   STARTUPINFO,PROCESSINFO) then begin
    Repeat
      While PeekMessage(Msg,0,0,0,PM_REMOVE) do begin
        If Msg.message = WM_QUIT then Halt(Msg.wParam);
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      end;
      GetExitCodeProcess(PROCESSINFO.hProcess,lpExitCode);
      decodetime (sysutils.time-stime,hrs,mins,secs,msecs);
      hrs:=hrs*60+mins;
      hrs:=hrs*60+secs;
      If (TimeOut > 0) and (TimeOut < hrs) then begin
        Result := 1;
        If AllowKill then begin
          If TerminateProcess(PROCESSINFO.hProcess,0) then
            Result := 2
          else
            Result := 3;
        end;
        Break;
      end;
    Until lpExitCode <> STILL_ACTIVE;
    With PROCESSINFO do begin
      CloseHandle(hThread);
      CloseHandle(hProcess);
    end;
    If Result = 0 then Result := lpExitCode;
  end
  else Result := GetLastError;
end;

Procedure Reboot;
Var sTokenIn,sTokenOut : TTOKENPRIVILEGES ;
    dwLen : DWORD ;
    hCurrentProcess,hToken : THANDLE ;
    Luid1 : TLargeInteger ;  // LUID ;
Begin
  // Handle du process en cours
  hCurrentProcess := GetCurrentProcess ;
  OpenProcessToken (hCurrentProcess,TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken);
  // valeur du privilege SHUTDOWN
  LookupPrivilegeValue(nil,'SeShutdownPrivilege',Luid1) ;
  sTokenIn.PrivilegeCount := 1;
  sTokenIn.Privileges[0].Luid := Luid1;
  sTokenIn.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
  // Ajustement du privilege avec les nouvelles valeurs
  AdjustTokenPrivileges ( hToken, FALSE, sTokenIn,sizeof(TTOKENPRIVILEGES),sTokenOut, dwLen);
  CloseHandle (hToken);
  ExitWindowsEx(EWX_REBOOT {or EWX_FORCE}, 0) ;//Sortie NT
End;

